/***

The MIT License

Copyright (c) 2018 Teppei Tamra (TAM)

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

***/

#ifndef SAORICACHE_H
#define SAORICACHE_H

#include <QObject>
#include <QUrl>
#include <QList>

class SaoriCache : public QObject
{
    Q_OBJECT
public:
    explicit SaoriCache(QObject *parent = nullptr);
    void removeFileCache(const QUrl url);
    void reloadFileCache(const QUrl url);
    const QString fileCache(const QUrl url);

protected:
    static QList<QUrl> m_nowloading;

protected:
    bool migration();
    void download(const QUrl url);
    bool isCached(const QUrl url);
    static const QString urlToFilename(QUrl url);
    const QString localfileName(const QUrl url);

signals:
    void downloaded(const QUrl);

public slots:
};

#endif // SAORICACHE_H
